<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackagesCodeList ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackagesCodeList extends AbstractStructArrayBase
{
    /**
     * The Package
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackagesCodeList[]
     */
    public $Package;
    /**
     * Constructor method for ArrayOfJP_PackagesCodeList
     * @uses ArrayOfJP_PackagesCodeList::setPackage()
     * @param \StructType\JP_PackagesCodeList[] $package
     */
    public function __construct(array $package = array())
    {
        $this
            ->setPackage($package);
    }
    /**
     * Get Package value
     * @return \StructType\JP_PackagesCodeList[]|null
     */
    public function getPackage()
    {
        return $this->Package;
    }
    /**
     * Set Package value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackagesCodeList[] $package
     * @return \ArrayType\ArrayOfJP_PackagesCodeList
     */
    public function setPackage(array $package = array())
    {
        foreach ($package as $arrayOfJP_PackagesCodeListPackageItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackagesCodeListPackageItem instanceof \StructType\JP_PackagesCodeList) {
                throw new \InvalidArgumentException(sprintf('The Package property can only contain items of \StructType\JP_PackagesCodeList, "%s" given', is_object($arrayOfJP_PackagesCodeListPackageItem) ? get_class($arrayOfJP_PackagesCodeListPackageItem) : gettype($arrayOfJP_PackagesCodeListPackageItem)), __LINE__);
            }
        }
        $this->Package = $package;
        return $this;
    }
    /**
     * Add item to Package value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackagesCodeList $item
     * @return \ArrayType\ArrayOfJP_PackagesCodeList
     */
    public function addToPackage(\StructType\JP_PackagesCodeList $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackagesCodeList) {
            throw new \InvalidArgumentException(sprintf('The Package property can only contain items of \StructType\JP_PackagesCodeList, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Package[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackagesCodeList|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackagesCodeList|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackagesCodeList|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackagesCodeList|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackagesCodeList|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Package
     */
    public function getAttributeName()
    {
        return 'Package';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_PackagesCodeList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
